#include <iostream>
#include "share.h"

#define NAME_SHARE_MEMORY   "MY_SHARE_MEMORY2"
#define NAME_SHARE_MAP_TYPE "MY_SHARE_MAP2"
#define NAME_SHARE_DEQUE    "MY_SHARE_DEQUE2"

struct Type { // произвольная структура
  int id;
  shm_string data;
  Type(const char_allocator &ca) : data(ca) {}
};


int main () {
  if(!Share::exist(NAME_SHARE_MEMORY)) {
    std::cout << "shared memory not exists " << NAME_SHARE_MEMORY << std::endl;
    return 1;
  } 
  Share mem(NAME_SHARE_MEMORY);
  ShareDeque<Type> d = mem.openShareDeque<Type>(NAME_SHARE_DEQUE);
  
  std::cout << "memory total=" << mem.get_size() << std::endl;
  std::cout << "memory free=" << mem.get_free_memory() << std::endl;
  std::cout << "deque name=" << d.get_name() << std::endl;
  std::cout << "deque exist=" << d.exist() << std::endl;
  std::cout << "deque size=" << d.size() << std::endl;
  std::cout << "deque max_size=" << d.max_size() << std::endl;
  
  
  ShareDeque<Type>::PElemType B = d.pop();
  if(B)
    std::cout << "pop=" << B->data << std::endl;
  else
    std::cout << "pop=NULL" << std::endl;
  std::cout << mem.get_free_memory() << std::endl;
  mem.deallocate(B.get());

  std::cout << "memory total=" << mem.get_size() << std::endl;
  std::cout << "memory free=" << mem.get_free_memory() << std::endl;
  std::cout << "deque name=" << d.get_name() << std::endl;
  std::cout << "deque exist=" << d.exist() << std::endl;
  std::cout << "deque size=" << d.size() << std::endl;
  std::cout << "deque max_size=" << d.max_size() << std::endl;

  return 0;
}
