#include <iostream>
#include "share.h"

#define NAME_SHARE_MEMORY   "MY_SHARE_MEMORY2"
#define NAME_SHARE_MAP_TYPE "MY_SHARE_MAP2"
#define NAME_SHARE_DEQUE    "MY_SHARE_DEQUE2"
#define SIZE_SHARE_MEMORY   10000
#define SIZE_SHARE_DEQUE    15

struct Type { // произвольная структура
  int id;
  shm_string data;
  Type(const char_allocator &ca) : data(ca) {}
};

int main (int argc, char **argv) {
  if(argc==2 &&  strcmp(argv[1], "--delete")==0 ) {
    Share::remove(NAME_SHARE_MEMORY);
  }    
  
  Share mem(NAME_SHARE_MEMORY, SIZE_SHARE_MEMORY);
  
  ShareDeque<Type> d = mem.createShareDeque<Type>(NAME_SHARE_DEQUE, SIZE_SHARE_DEQUE);//, SIZE_SHARE_DEQUE
  
  std::cout << "memory total=" << mem.get_size() << std::endl;
  std::cout << "memory free=" << mem.get_free_memory() << std::endl;
  std::cout << "deque name=" << d.get_name() << std::endl;
  std::cout << "deque exist=" << d.exist() << std::endl;
  std::cout << "deque size=" << d.size() << std::endl;
  std::cout << "deque max_size=" << d.max_size() << std::endl;
  
  Type a = mem.create<Type>();
  a.data = "Hello, Deque!";
  d.push(a);
  
  std::cout << "memory total=" << mem.get_size() << std::endl;
  std::cout << "memory free=" << mem.get_free_memory() << std::endl;
  std::cout << "deque name=" << d.get_name() << std::endl;
  std::cout << "deque exist=" << d.exist() << std::endl;
  std::cout << "deque size=" << d.size() << std::endl;
  std::cout << "deque max_size=" << d.max_size() << std::endl;
  
  return 0;
}
